Index: i386/i386/mpapic.c
===================================================================
RCS file: /cvs/src/sys/i386/i386/mpapic.c,v
retrieving revision 1.7
diff -u -r1.7 mpapic.c
--- i386/i386/mpapic.c	26 Aug 2003 21:42:18 -0000	1.7
+++ i386/i386/mpapic.c	23 Feb 2004 07:05:03 -0000
@@ -514,12 +514,13 @@
 	return 0;
 }
 
-static int
-apic_ipi_singledest(int cpu, int vector, int delivery_mode)
+void
+single_apic_ipi(int cpu, int vector, int delivery_mode)
 {
 	u_long  icr_lo;
 	u_long  icr_hi;
 
+	crit_enter();
 	if ((lapic.icr_lo & APIC_DELSTAT_MASK) != 0) {
 	    unsigned int eflags = read_eflags();
 	    cpu_enable_intr();
@@ -538,9 +539,44 @@
 
 	/* write APIC ICR */
 	lapic.icr_lo = icr_lo;
-	return 0;
+	crit_exit();
+}
+
+#if 0	
+
+/*
+ * Returns 0 if the apic is busy, 1 if we were able to queue the request.
+ *
+ * NOT WORKING YET!  The code as-is may end up not queueing an IPI at all
+ * to the target, and the scheduler does not 'poll' for IPI messages.
+ */
+int
+single_apic_ipi_passive(int cpu, int vector, int delivery_mode)
+{
+	u_long  icr_lo;
+	u_long  icr_hi;
+
+	crit_enter();
+	if ((lapic.icr_lo & APIC_DELSTAT_MASK) != 0) {
+	    crit_exit();
+	    return(0);
+	}
+	icr_hi = lapic.icr_hi & ~APIC_ID_MASK;
+	icr_hi |= (CPU_TO_ID(cpu) << 24);
+	lapic.icr_hi = icr_hi;
+
+	/* build IRC_LOW */
+	icr_lo = (lapic.icr_lo & APIC_RESV2_MASK)
+	    | APIC_DEST_DESTFLD | delivery_mode | vector;
+
+	/* write APIC ICR */
+	lapic.icr_lo = icr_lo;
+	crit_exit();
+	return(1);
 }
 
+#endif
+
 /*
  * Send APIC IPI 'vector' to 'target's via 'delivery_mode'.
  *
@@ -548,20 +584,16 @@
  * valid system INT vector.  Delivery mode may be either
  * APIC_DELMODE_FIXED or APIC_DELMODE_LOWPRIO.
  */
-int
+void
 selected_apic_ipi(u_int target, int vector, int delivery_mode)
 {
-	int status = 0;
-
 	crit_enter();
 	while (target) {
 		int n = bsfl(target);
 		target &= ~(1 << n);
-		if (apic_ipi_singledest(n, vector, delivery_mode) < 0)
-			status |= 1 << n;
+		single_apic_ipi(n, vector, delivery_mode);
 	}
 	crit_exit();
-	return(status);
 }
 
 #endif	/* APIC_IO */
Index: i386/i386/nexus.c
===================================================================
RCS file: /cvs/src/sys/i386/i386/nexus.c,v
retrieving revision 1.9
diff -u -r1.9 nexus.c
--- i386/i386/nexus.c	23 Feb 2004 21:23:42 -0000	1.9
+++ i386/i386/nexus.c	23 Feb 2004 21:24:01 -0000
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  *
  * $FreeBSD: src/sys/i386/i386/nexus.c,v 1.26.2.10 2003/02/22 13:16:45 imp Exp $
- * $DragonFly: src/sys/i386/i386/nexus.c,v 1.9 2004/02/23 21:23:42 dillon Exp $
+ * $DragonFly$
  */
 
 /*
@@ -82,6 +82,7 @@
 
 static struct rman irq_rman, drq_rman, port_rman, mem_rman;
 
+static void nexus_identify(driver_t *, device_t);
 static	int nexus_probe(device_t);
 static	int nexus_attach(device_t);
 static	int nexus_print_all_resources(device_t dev);
@@ -108,6 +109,7 @@
 
 static device_method_t nexus_methods[] = {
 	/* Device interface */
+	DEVMETHOD(device_identify,	nexus_identify),
 	DEVMETHOD(device_probe,		nexus_probe),
 	DEVMETHOD(device_attach,	nexus_attach),
 	DEVMETHOD(device_detach,	bus_generic_detach),
@@ -142,9 +144,32 @@
 
 DRIVER_MODULE(nexus, root, nexus_driver, nexus_devclass, 0, 0);
 
+static void
+nexus_identify(driver_t *driver, device_t parent)
+{
+        /*
+         * Add child device with order of 1 so it gets probed
+         * after ACPI (which is at order 0.
+         */
+        if (BUS_ADD_CHILD(parent, 1, "legacy", 0) == NULL)
+                panic("legacy: could not attach");
+}
+
 static int
 nexus_probe(device_t dev)
 {
+#if 0	/* FUTURE */
+	device_t acpi;
+#endif
+
+#if 0	/* FUTURE */
+	/*
+	 * Fail to probe if ACPI is ok.
+	 */
+	acpi = devclass_get_device(devclass_find("acpi"), 0);
+	if (acpi != NULL && device_is_alive(acpi))
+		return(ENXIO);
+#endif
 
 	device_quiet(dev);	/* suppress attach message for neatness */
 
@@ -229,9 +254,15 @@
 	device_t	child;
 
 	/*
-	 * First, deal with the children we know about already
+	 * First, let our child driver's identify any child devices that
+	 * they can find.  Once that is done attach any devices that we
+	 * found.
 	 */
+#if 0 /* FUTURE */
+	bus_generic_probe(dev);
+#endif
 	bus_generic_attach(dev);
+
 	/*
 	 * And if we didn't see EISA or ISA on a pci bridge, create some
 	 * connection points now so they show up "on motherboard".
Index: i386/i386/pmap.c
===================================================================
RCS file: /cvs/src/sys/i386/i386/pmap.c,v
retrieving revision 1.31
diff -u -r1.31 pmap.c
--- i386/i386/pmap.c	21 Feb 2004 06:37:07 -0000	1.31
+++ i386/i386/pmap.c	22 Feb 2004 07:21:40 -0000
@@ -1535,7 +1535,7 @@
 	 * the SMP case.
 	 */
 	if (oldpte & PG_G)
-		cpu_invlpg(va);
+		cpu_invlpg((void *)va);
 	pmap->pm_stats.resident_count -= 1;
 	if (oldpte & PG_MANAGED) {
 		m = PHYS_TO_VM_PAGE(oldpte);
Index: i386/include/mpapic.h
===================================================================
RCS file: /cvs/src/sys/i386/include/mpapic.h,v
retrieving revision 1.6
diff -u -r1.6 mpapic.h
--- i386/include/mpapic.h	21 Feb 2004 06:37:07 -0000	1.6
+++ i386/include/mpapic.h	21 Feb 2004 21:26:02 -0000
@@ -64,18 +64,6 @@
 #ifdef SMP
 
 /*
- * send an IPI INTerrupt containing 'vector' to CPUs in 'targetMap'
- * 'targetMap' is a bitfiled of length 14,
- *   APIC #0 == bit 0, ..., APIC #14 == bit 14
- *   NOTE: these are LOGICAL APIC IDs
- */
-static __inline int
-selected_procs_ipi(int targetMap, int vector)
-{
-	return selected_apic_ipi(targetMap, vector, APIC_DELMODE_FIXED);
-}
-
-/*
  * send an IPI INTerrupt containing 'vector' to all CPUs EXCEPT myself
  */
 static __inline int
Index: i386/include/smp.h
===================================================================
RCS file: /cvs/src/sys/i386/include/smp.h,v
retrieving revision 1.10
diff -u -r1.10 smp.h
--- i386/include/smp.h	21 Feb 2004 06:37:07 -0000	1.10
+++ i386/include/smp.h	22 Feb 2004 22:50:01 -0000
@@ -128,7 +128,9 @@
 void	apic_initialize		(void);
 void	imen_dump		(void);
 int	apic_ipi		(int, int, int);
-int	selected_apic_ipi	(u_int, int, int);
+void	selected_apic_ipi	(u_int, int, int);
+void	single_apic_ipi(int cpu, int vector, int delivery_mode);
+int	single_apic_ipi_passive(int cpu, int vector, int delivery_mode);
 int	io_apic_setup		(int);
 void	io_apic_setup_intpin	(int, int);
 void	io_apic_set_id		(int, int);
@@ -144,6 +146,7 @@
 int	read_apic_timer		(void);
 void	u_sleep			(int);
 void	cpu_send_ipiq		(int);
+int	cpu_send_ipiq_passive	(int);
 
 /* global data in init_smp.c */
 extern cpumask_t		smp_active_mask;
Index: kern/imgact_elf.c
===================================================================
RCS file: /cvs/src/sys/kern/imgact_elf.c,v
retrieving revision 1.16
diff -u -r1.16 imgact_elf.c
--- kern/imgact_elf.c	20 Jan 2004 18:41:51 -0000	1.16
+++ kern/imgact_elf.c	22 Feb 2004 19:04:49 -0000
@@ -387,7 +387,7 @@
 	 */
 	error = exec_check_permissions(imgp);
 	if (error) {
-		VOP_UNLOCK(nd->ni_vp, 0, td);
+		VOP_UNLOCK(nd->ni_vp, NULL, 0, td);
 		goto fail;
 	}
 
@@ -398,7 +398,7 @@
 	 */
 	if (error == 0)
 		nd->ni_vp->v_flag |= VTEXT;
-	VOP_UNLOCK(nd->ni_vp, 0, td);
+	VOP_UNLOCK(nd->ni_vp, NULL, 0, td);
 	if (error)
                 goto fail;
 
@@ -492,6 +492,7 @@
 	const char *interp = NULL;
 	Elf_Brandinfo *brand_info;
 	char *path;
+	lwkt_tokref ilock;
 
 	error = 0;
 
@@ -525,9 +526,9 @@
 	 * a context switch.  Better safe than sorry; I really don't want
 	 * the file to change while it's being loaded.
 	 */
-	lwkt_gettoken(&imgp->vp->v_interlock);
+	lwkt_gettoken(&ilock, imgp->vp->v_interlock);
 	imgp->vp->v_flag |= VTEXT;
-	lwkt_reltoken(&imgp->vp->v_interlock);
+	lwkt_reltoken(&ilock);
 
 	vmspace = imgp->proc->p_vmspace;
 
@@ -815,7 +816,7 @@
 	fp->f_flag = O_CREAT|O_WRONLY|O_NOFOLLOW;
 	fp->f_ops = &vnops;
 	fp->f_type = DTYPE_VNODE;
-	VOP_UNLOCK(vp, 0, p->p_thread);
+	VOP_UNLOCK(vp, NULL, 0, p->p_thread);
 	
 	error = generic_elf_coredump(p, fp, limit);
 
Index: kern/init_main.c
===================================================================
RCS file: /cvs/src/sys/kern/init_main.c,v
retrieving revision 1.27
diff -u -r1.27 init_main.c
--- kern/init_main.c	30 Jan 2004 05:42:17 -0000	1.27
+++ kern/init_main.c	23 Feb 2004 03:15:38 -0000
@@ -465,7 +465,7 @@
 	p->p_fd->fd_rdir = rootvnode;
 	VREF(p->p_fd->fd_rdir);
 	vfs_cache_setroot(rootvnode);
-	VOP_UNLOCK(rootvnode, 0, curthread);
+	VOP_UNLOCK(rootvnode, NULL, 0, curthread);
 
 	/*
 	 * Need just enough stack to hold the faked-up "execve()" arguments.
@@ -613,6 +613,7 @@
 	TAILQ_INIT(&gd->gd_systimerq);
 	gd->gd_cpuid = cpuid;
 	lwkt_gdinit(gd);
+	vm_map_entry_reserve_cpu_init(gd);
 }
 
 
Index: kern/kern_acct.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_acct.c,v
retrieving revision 1.8
diff -u -r1.8 kern_acct.c
--- kern/kern_acct.c	29 Sep 2003 18:52:06 -0000	1.8
+++ kern/kern_acct.c	22 Feb 2004 05:34:32 -0000
@@ -136,7 +136,7 @@
 		if (error)
 			return (error);
 		NDFREE(&nd, NDF_ONLY_PNBUF);
-		VOP_UNLOCK(nd.ni_vp, 0, td);
+		VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
 		if (nd.ni_vp->v_type != VREG) {
 			vn_close(nd.ni_vp, FWRITE | O_APPEND, td);
 			return (EACCES);
Index: kern/kern_acl.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_acl.c,v
retrieving revision 1.5
diff -u -r1.5 kern_acl.c
--- kern/kern_acl.c	23 Sep 2003 05:03:51 -0000	1.5
+++ kern/kern_acl.c	22 Feb 2004 05:51:06 -0000
@@ -80,9 +80,9 @@
 	ucred = td->td_proc->p_ucred;
 
 	VOP_LEASE(vp, td, ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_SETACL(vp, type, &inkernacl, ucred, td);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return(error);
 }
 
@@ -118,9 +118,9 @@
 	KKASSERT(td->td_proc);
 	ucred = td->td_proc->p_ucred;
 	VOP_LEASE(vp, td, ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_SETACL(vp, ACL_TYPE_DEFAULT, 0, ucred, td);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (error);
 }
 
Index: kern/kern_descrip.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_descrip.c,v
retrieving revision 1.18
diff -u -r1.18 kern_descrip.c
--- kern/kern_descrip.c	17 Jan 2004 21:23:38 -0000	1.18
+++ kern/kern_descrip.c	22 Feb 2004 05:34:44 -0000
@@ -1353,7 +1353,7 @@
                        fp->f_flag = flags;
                        fp->f_ops = &vnops;
                        fp->f_type = DTYPE_VNODE;
-                       VOP_UNLOCK(nd.ni_vp, 0, td);
+                       VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
                        devnull = fd;
                } else {
                        error = kern_dup(DUP_FIXED, devnull, i, &retval);
Index: kern/kern_exec.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_exec.c,v
retrieving revision 1.19
diff -u -r1.19 kern_exec.c
--- kern/kern_exec.c	20 Jan 2004 18:41:51 -0000	1.19
+++ kern/kern_exec.c	22 Feb 2004 05:34:52 -0000
@@ -186,12 +186,12 @@
 	 */
 	error = exec_check_permissions(imgp);
 	if (error) {
-		VOP_UNLOCK(imgp->vp, 0, td);
+		VOP_UNLOCK(imgp->vp, NULL, 0, td);
 		goto exec_fail_dealloc;
 	}
 
 	error = exec_map_first_page(imgp);
-	VOP_UNLOCK(imgp->vp, 0, td);
+	VOP_UNLOCK(imgp->vp, NULL, 0, td);
 	if (error)
 		goto exec_fail_dealloc;
 
Index: kern/kern_fp.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_fp.c,v
retrieving revision 1.4
diff -u -r1.4 kern_fp.c
--- kern/kern_fp.c	19 Oct 2003 23:23:26 -0000	1.4
+++ kern/kern_fp.c	22 Feb 2004 05:35:07 -0000
@@ -105,7 +105,7 @@
 	fp->f_flag = flags;
 	fp->f_ops = &vnops;
 	fp->f_type = DTYPE_VNODE;
-	VOP_UNLOCK(nd.ni_vp, 0, td);
+	VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
     } else {
 	fdrop(fp, td);
 	*fpp = NULL;
@@ -191,7 +191,7 @@
     if (flags & FWRITE)
 	vp->v_writecount++;
 done:
-    VOP_UNLOCK(vp, 0, td);
+    VOP_UNLOCK(vp, NULL, 0, td);
     return (error);
 }
 
Index: kern/kern_ktrace.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_ktrace.c,v
retrieving revision 1.12
diff -u -r1.12 kern_ktrace.c
--- kern/kern_ktrace.c	14 Feb 2004 12:14:30 -0000	1.12
+++ kern/kern_ktrace.c	22 Feb 2004 05:51:09 -0000
@@ -268,7 +268,7 @@
 		}
 		NDFREE(&nd, NDF_ONLY_PNBUF);
 		vp = nd.ni_vp;
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 		if (vp->v_type != VREG) {
 			(void) vn_close(vp, FREAD|FWRITE, td);
 			curp->p_traceflag &= ~KTRFAC_ACTIVE;
@@ -487,14 +487,14 @@
 		if (uio != NULL)
 			kth->ktr_len += uio->uio_resid;
 	}
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	(void)VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
 	error = VOP_WRITE(vp, &auio, IO_UNIT | IO_APPEND, p->p_ucred);
 	if (error == 0 && uio != NULL) {
 		(void)VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
 		error = VOP_WRITE(vp, uio, IO_UNIT | IO_APPEND, p->p_ucred);
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (!error)
 		return;
 	/*
Index: kern/kern_linker.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_linker.c,v
retrieving revision 1.17
diff -u -r1.17 kern_linker.c
--- kern/kern_linker.c	17 Jan 2004 03:24:50 -0000	1.17
+++ kern/kern_linker.c	22 Feb 2004 05:35:17 -0000
@@ -326,14 +326,14 @@
 	goto out;
     sprintf(koname, "%s.ko", filename);
 
-    lockmgr(&lock, LK_SHARED, 0, curthread);
+    lockmgr(&lock, LK_SHARED, NULL, curthread);
     for (lf = TAILQ_FIRST(&linker_files); lf; lf = TAILQ_NEXT(lf, link)) {
 	if (!strcmp(lf->filename, koname))
 	    break;
 	if (!strcmp(lf->filename, filename))
 	    break;
     }
-    lockmgr(&lock, LK_RELEASE, 0, curthread);
+    lockmgr(&lock, LK_RELEASE, NULL, curthread);
 
 out:
     if (koname)
@@ -346,11 +346,11 @@
 {
     linker_file_t lf = 0;
 
-    lockmgr(&lock, LK_SHARED, 0, curthread);
+    lockmgr(&lock, LK_SHARED, NULL, curthread);
     for (lf = TAILQ_FIRST(&linker_files); lf; lf = TAILQ_NEXT(lf, link))
 	if (lf->id == fileid)
 	    break;
-    lockmgr(&lock, LK_RELEASE, 0, curthread);
+    lockmgr(&lock, LK_RELEASE, NULL, curthread);
 
     return lf;
 }
@@ -369,7 +369,7 @@
 	filename = pathname;
 
     KLD_DPF(FILE, ("linker_make_file: new file, filename=%s\n", filename));
-    lockmgr(&lock, LK_EXCLUSIVE, 0, curthread);
+    lockmgr(&lock, LK_EXCLUSIVE, NULL, curthread);
     namelen = strlen(filename) + 1;
     lf = malloc(sizeof(struct linker_file) + namelen, M_LINKER, M_WAITOK);
     if (!lf)
@@ -392,7 +392,7 @@
     TAILQ_INSERT_TAIL(&linker_files, lf, link);
 
 out:
-    lockmgr(&lock, LK_RELEASE, 0, curthread);
+    lockmgr(&lock, LK_RELEASE, NULL, curthread);
     return lf;
 }
 
@@ -409,7 +409,7 @@
 	return EPERM; 
 
     KLD_DPF(FILE, ("linker_file_unload: lf->refs=%d\n", file->refs));
-    lockmgr(&lock, LK_EXCLUSIVE, 0, curthread);
+    lockmgr(&lock, LK_EXCLUSIVE, NULL, curthread);
     if (file->refs == 1) {
 	KLD_DPF(FILE, ("linker_file_unload: file is unloading, informing modules\n"));
 	/*
@@ -430,7 +430,7 @@
 	    if ((error = module_unload(mod)) != 0) {
 		KLD_DPF(FILE, ("linker_file_unload: module %x vetoes unload\n",
 			       mod));
-		lockmgr(&lock, LK_RELEASE, 0, curthread);
+		lockmgr(&lock, LK_RELEASE, NULL, curthread);
 		goto out;
 	    }
 
@@ -459,7 +459,7 @@
 
     file->refs--;
     if (file->refs > 0) {
-	lockmgr(&lock, LK_RELEASE, 0, curthread);
+	lockmgr(&lock, LK_RELEASE, NULL, curthread);
 	goto out;
     }
 
@@ -470,7 +470,7 @@
     }
 
     TAILQ_REMOVE(&linker_files, file, link);
-    lockmgr(&lock, LK_RELEASE, 0, curthread);
+    lockmgr(&lock, LK_RELEASE, NULL, curthread);
 
     for (i = 0; i < file->ndeps; i++)
 	linker_file_unload(file->deps[i]);
@@ -1129,7 +1129,7 @@
 	if (error == 0) {
 	    NDFREE(&nd, NDF_ONLY_PNBUF);
 	    type = nd.ni_vp->v_type;
-	    VOP_UNLOCK(nd.ni_vp, 0, td);
+	    VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
 	    vn_close(nd.ni_vp, FREAD, td);
 	    if (type == VREG)
 		return(result);
Index: kern/kern_lock.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_lock.c,v
retrieving revision 1.9
diff -u -r1.9 kern_lock.c
--- kern/kern_lock.c	12 Nov 2003 22:08:02 -0000	1.9
+++ kern/kern_lock.c	23 Feb 2004 08:36:31 -0000
@@ -123,10 +123,9 @@
 	while ((lkp->lk_flags & wanted) != 0) {
 		lkp->lk_flags |= LK_WAIT_NONZERO;
 		lkp->lk_waitcount++;
-		lwkt_reltoken(&lkp->lk_interlock);
+		/* note: serialization lock is held through tsleep */
 		error = tsleep(lkp, lkp->lk_prio, lkp->lk_wmesg, 
 			    ((extflags & LK_TIMELOCK) ? lkp->lk_timo : 0));
-		lwkt_gettoken(&lkp->lk_interlock);
 		if (lkp->lk_waitcount == 1) {
 			lkp->lk_flags &= ~LK_WAIT_NONZERO;
 			lkp->lk_waitcount = 0;
@@ -155,15 +154,16 @@
  */
 int
 #ifndef	DEBUG_LOCKS
-lockmgr(struct lock *lkp, u_int flags, struct lwkt_token *interlkp,
+lockmgr(struct lock *lkp, u_int flags, lwkt_tokref_t interlkp,
 	struct thread *td)
 #else
-debuglockmgr(struct lock *lkp, u_int flags, struct lwkt_token *interlkp,
+debuglockmgr(struct lock *lkp, u_int flags, lwkt_tokref_t interlkp,
 	struct thread *td, const char *name, const char *file, int line)
 #endif
 {
 	int error;
 	int extflags;
+	lwkt_tokref ilock;
 	static int didpanic;
 
 	error = 0;
@@ -198,7 +198,7 @@
 #endif
 	}
 
-	lwkt_gettoken(&lkp->lk_interlock);
+	lwkt_gettoken(&ilock, &lkp->lk_interlock);
 	if (flags & LK_INTERLOCK)
 		lwkt_reltoken(interlkp);
 
@@ -427,7 +427,7 @@
 		break;
 
 	default:
-		lwkt_reltoken(&lkp->lk_interlock);
+		lwkt_reltoken(&ilock);
 		panic("lockmgr: unknown locktype request %d",
 		    flags & LK_TYPE_MASK);
 		/* NOTREACHED */
@@ -438,7 +438,7 @@
 		lkp->lk_flags &= ~LK_WAITDRAIN;
 		wakeup((void *)&lkp->lk_flags);
 	}
-	lwkt_reltoken(&lkp->lk_interlock);
+	lwkt_reltoken(&ilock);
 	return (error);
 }
 
@@ -456,11 +456,10 @@
 
 	while (lkp->lk_flags & LK_ALL) {
 		lkp->lk_flags |= LK_WAITDRAIN;
-		lwkt_reltoken(&lkp->lk_interlock);
+		/* interlock serialization held through tsleep */
 		error = tsleep(&lkp->lk_flags, lkp->lk_prio,
 			lkp->lk_wmesg, 
 			((extflags & LK_TIMELOCK) ? lkp->lk_timo : 0));
-		lwkt_gettoken(&lkp->lk_interlock);
 		if (error)
 			return error;
 		if (extflags & LK_SLEEPFAIL) {
@@ -481,7 +480,7 @@
 	int timo;
 	int flags;
 {
-	lwkt_inittoken(&lkp->lk_interlock);
+	lwkt_token_init(&lkp->lk_interlock);
 	lkp->lk_flags = (flags & LK_EXTFLG_MASK);
 	lkp->lk_sharecount = 0;
 	lkp->lk_waitcount = 0;
@@ -498,9 +497,10 @@
 int
 lockstatus(struct lock *lkp, struct thread *td)
 {
+	lwkt_tokref ilock;
 	int lock_type = 0;
 
-	lwkt_gettoken(&lkp->lk_interlock);
+	lwkt_gettoken(&ilock, &lkp->lk_interlock);
 	if (lkp->lk_exclusivecount != 0) {
 		if (td == NULL || lkp->lk_lockholder == td)
 			lock_type = LK_EXCLUSIVE;
@@ -509,7 +509,7 @@
 	} else if (lkp->lk_sharecount != 0) {
 		lock_type = LK_SHARED;
 	}
-	lwkt_reltoken(&lkp->lk_interlock);
+	lwkt_reltoken(&ilock);
 	return (lock_type);
 }
 
@@ -520,11 +520,12 @@
 lockcount(lkp)
 	struct lock *lkp;
 {
+	lwkt_tokref ilock;
 	int count;
 
-	lwkt_gettoken(&lkp->lk_interlock);
+	lwkt_gettoken(&ilock, &lkp->lk_interlock);
 	count = lkp->lk_exclusivecount + lkp->lk_sharecount;
-	lwkt_reltoken(&lkp->lk_interlock);
+	lwkt_reltoken(&ilock);
 	return (count);
 }
 
Index: kern/kern_sig.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_sig.c,v
retrieving revision 1.26
diff -u -r1.26 kern_sig.c
--- kern/kern_sig.c	12 Feb 2004 06:57:48 -0000	1.26
+++ kern/kern_sig.c	22 Feb 2004 05:51:13 -0000
@@ -1467,7 +1467,7 @@
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vp = nd.ni_vp;
 
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	lf.l_whence = SEEK_SET;
 	lf.l_start = 0;
 	lf.l_len = 0;
@@ -1484,12 +1484,12 @@
 	}
 
 	VATTR_NULL(&vattr);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	vattr.va_size = 0;
 	VOP_LEASE(vp, td, cred, LEASE_WRITE);
 	VOP_SETATTR(vp, &vattr, cred, td);
 	p->p_acflag |= ACORE;
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 
 	error = p->p_sysent->sv_coredump ?
 	  p->p_sysent->sv_coredump(p, vp, limit) :
Index: kern/kern_switch.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_switch.c,v
retrieving revision 1.17
diff -u -r1.17 kern_switch.c
--- kern/kern_switch.c	12 Feb 2004 06:57:48 -0000	1.17
+++ kern/kern_switch.c	23 Feb 2004 08:20:42 -0000
@@ -39,6 +39,7 @@
 #include <sys/sysctl.h>
 #include <machine/ipl.h>
 #include <machine/cpu.h>
+#include <machine/smp.h>
 
 /*
  * debugging only YYY Remove me!   define to schedule user processes only
@@ -64,8 +65,8 @@
 static u_int32_t queuebits;
 static u_int32_t rtqueuebits;
 static u_int32_t idqueuebits;
-static u_int32_t curprocmask = -1;	/* currently running a user process */
-static u_int32_t rdyprocmask;		/* ready to accept a user process */
+static cpumask_t curprocmask = -1;	/* currently running a user process */
+static cpumask_t rdyprocmask;		/* ready to accept a user process */
 static int	 runqcount;
 #ifdef SMP
 static int	 scancpu;
@@ -93,6 +94,8 @@
         &choose_affinity, 0, "chooseproc() was smart");
 #endif
 
+static void sched_thread_cpu_init(void);
+
 #define USCHED_COUNTER(td)	((td->td_gd == mycpu) ? ++usched_optimal : ++usched_steal)
 
 /*
@@ -108,11 +111,7 @@
 		TAILQ_INIT(&rtqueues[i]);
 		TAILQ_INIT(&idqueues[i]);
 	}
-#ifdef SMP
-	sched_thread_init();
-#else
 	curprocmask &= ~1;
-#endif
 }
 SYSINIT(runqueue, SI_SUB_RUN_QUEUE, SI_ORDER_FIRST, rqinit, NULL)
 
@@ -249,7 +248,7 @@
 	int cpuid;
 #ifdef SMP
 	int count;
-	u_int32_t mask;
+	cpumask_t mask;
 #endif
 
 	crit_enter();
@@ -379,6 +378,11 @@
 	 * We depress the priority check so multiple cpu bound programs
 	 * do not bounce between cpus.  Remember that the clock interrupt
 	 * will also cause all cpus to reschedule.
+	 *
+	 * We must mask against rdyprocmask or we will race in the boot
+	 * code (before all cpus have working scheduler helpers), plus
+	 * some cpus might not be operational and/or not configured to
+	 * handle user processes.
 	 */
 	if (count && remote_resched && ncpus > 1) {
 		cpuid = scancpu;
@@ -388,12 +392,14 @@
 		} while (cpuid == mycpu->gd_cpuid);
 		scancpu = cpuid;
 
-		gd = globaldata_find(cpuid);
+		if (rdyprocmask & (1 << cpuid)) {
+			gd = globaldata_find(cpuid);
 
-		if (p->p_priority / PPQ < gd->gd_upri / PPQ - 2) {
-			gd->gd_upri = p->p_priority;
-			lwkt_send_ipiq(gd, need_resched_remote, NULL);
-			++remote_resched_nonaffinity;
+			if (p->p_priority / PPQ < gd->gd_upri / PPQ - 2) {
+				gd->gd_upri = p->p_priority;
+				lwkt_send_ipiq(gd, need_resched_remote, NULL);
+				++remote_resched_nonaffinity;
+			}
 		}
 	}
 #else
@@ -625,6 +631,7 @@
 	}
 }
 
+#ifdef SMP
 
 /*
  * For SMP systems a user scheduler helper thread is created for each
@@ -634,9 +641,6 @@
  * thread for this because we need to hold the MP lock.  Additionally,
  * doing things this way allows us to HLT idle cpus on MP systems.
  */
-
-#ifdef SMP
-
 static void
 sched_thread(void *dummy)
 {
@@ -667,21 +671,43 @@
     }
 }
 
-void
-sched_thread_init(void)
+/*
+ * Setup our scheduler helpers.  Note that curprocmask bit 0 has already
+ * been cleared by rqinit() and we should not mess with it further.
+ */
+static void
+sched_thread_cpu_init(void)
 {
-    int cpuid = mycpu->gd_cpuid;
+    int i;
+
+    if (bootverbose)
+	printf("start scheduler helpers on cpus:");
 
-    lwkt_create(sched_thread, NULL, NULL, &mycpu->gd_schedthread, 
-		TDF_STOPREQ, -1,
-		"usched %d", cpuid);
-    curprocmask &= ~(1 << cpuid);	/* schedule user proc on cpu */
+    for (i = 0; i < ncpus; ++i) {
+	globaldata_t dgd = globaldata_find(i);
+	cpumask_t mask = 1 << i;
+
+	if ((mask & smp_active_mask) == 0)
+	    continue;
+
+	if (bootverbose)
+	    printf(" %d", i);
+
+	lwkt_create(sched_thread, NULL, NULL, &dgd->gd_schedthread, 
+		    TDF_STOPREQ, i, "usched %d", i);
 #ifdef ONLY_ONE_USER_CPU
-    if (cpuid)
-	curprocmask |= 1 << cpuid;	/* DISABLE USER PROCS */
+	if (i)
+	    curprocmask |= mask;	/* DISABLE USER PROCS */
+#else
+	if (i)
+	    curprocmask &= ~mask;	/* schedule user proc on cpu */
 #endif
-    rdyprocmask |= 1 << cpuid;
+	rdyprocmask |= mask;
+    }
+    if (bootverbose)
+	printf("\n");
 }
+SYSINIT(uschedtd, SI_SUB_FINISH_SMP, SI_ORDER_ANY, sched_thread_cpu_init, NULL)
 
 #endif
 
Index: kern/link_aout.c
===================================================================
RCS file: /cvs/src/sys/kern/link_aout.c,v
retrieving revision 1.9
diff -u -r1.9 link_aout.c
--- kern/link_aout.c	13 Nov 2003 22:02:42 -0000	1.9
+++ kern/link_aout.c	22 Feb 2004 05:35:28 -0000
@@ -285,7 +285,7 @@
     *result = lf;
 
 out:
-    VOP_UNLOCK(nd.ni_vp, 0, td);
+    VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
     vn_close(nd.ni_vp, FREAD, td);
 
     return error;
Index: kern/link_elf.c
===================================================================
RCS file: /cvs/src/sys/kern/link_elf.c,v
retrieving revision 1.11
diff -u -r1.11 link_elf.c
--- kern/link_elf.c	17 Jan 2004 03:26:18 -0000	1.11
+++ kern/link_elf.c	22 Feb 2004 05:35:30 -0000
@@ -700,7 +700,7 @@
 	free(shdr, M_LINKER);
     if (firstpage)
 	free(firstpage, M_LINKER);
-    VOP_UNLOCK(nd.ni_vp, 0, td);
+    VOP_UNLOCK(nd.ni_vp, NULL, 0, td);
     vn_close(nd.ni_vp, FREAD, td);
 
     return error;
Index: kern/lwkt_ipiq.c
===================================================================
RCS file: /cvs/src/sys/kern/lwkt_ipiq.c,v
retrieving revision 1.3
diff -u -r1.3 lwkt_ipiq.c
--- kern/lwkt_ipiq.c	17 Feb 2004 19:38:49 -0000	1.3
+++ kern/lwkt_ipiq.c	23 Feb 2004 08:25:29 -0000
@@ -147,7 +147,7 @@
     windex = ip->ip_windex & MAXCPUFIFO_MASK;
     ip->ip_func[windex] = (ipifunc2_t)func;
     ip->ip_arg[windex] = arg;
-    /* YYY memory barrier */
+    cpu_mb1();
     ++ip->ip_windex;
     if (ip->ip_windex - ip->ip_rindex > MAXCPUFIFO / 2) {
 	unsigned int eflags = read_eflags();
@@ -166,6 +166,48 @@
 }
 
 /*
+ * Send an IPI request passively, return 0 on success and ENOENT on failure.
+ * This routine does not recursive through lwkt_process_ipiq() nor does it
+ * block trying to queue the actual IPI.  If we successfully queue the
+ * message but fail to queue the IPI, we still count it as a success.
+ * The occassional small race against a target cpu HLT is recovered at
+ * the next clock interrupt.
+ */
+int
+lwkt_send_ipiq_passive(globaldata_t target, ipifunc_t func, void *arg)
+{
+    lwkt_ipiq_t ip;
+    int windex;
+    struct globaldata *gd = mycpu;
+
+    KKASSERT(curthread->td_pri >= TDPRI_CRIT);
+    if (target == gd) {
+	func(arg);
+	return(0);
+    } 
+    ++ipiq_count;
+    ip = &gd->gd_ipiq[target->gd_cpuid];
+
+    if (ip->ip_windex - ip->ip_rindex >= MAXCPUFIFO - 1) {
+	return(ENOENT);
+    }
+    windex = ip->ip_windex & MAXCPUFIFO_MASK;
+    ip->ip_func[windex] = (ipifunc2_t)func;
+    ip->ip_arg[windex] = arg;
+    cpu_mb1();
+    ++ip->ip_windex;
+    /*
+     * passive mode doesn't work yet :-( 
+     */
+#if 1
+    cpu_send_ipiq(target->gd_cpuid);
+#else
+    cpu_send_ipiq_passive(target->gd_cpuid);
+#endif
+    return(0);
+}
+
+/*
  * deprecated, used only by fast int forwarding.
  */
 int
@@ -217,7 +259,9 @@
 	    unsigned int eflags = read_eflags();
 	    cpu_enable_intr();
 	    while ((int)(ip->ip_xindex - seq) < 0) {
+		crit_enter();
 		lwkt_process_ipiq();
+		crit_exit();
 		if (--maxc == 0)
 			printf("LWKT_WAIT_IPIQ WARNING! %d wait %d (%d)\n", mycpu->gd_cpuid, target->gd_cpuid, ip->ip_xindex - seq);
 		if (maxc < -1000000)
@@ -228,6 +272,15 @@
     }
 }
 
+int
+lwkt_seq_ipiq(globaldata_t target)
+{
+    lwkt_ipiq_t ip;
+
+    ip = &mycpu->gd_ipiq[target->gd_cpuid];
+    return(ip->ip_windex);
+}
+
 /*
  * Called from IPI interrupt (like a fast interrupt), which has placed
  * us in a critical section.  The MP lock may or may not be held.
@@ -434,7 +487,9 @@
 lwkt_cpusync_add(cpumask_t mask, lwkt_cpusync_t poll)
 {
     globaldata_t gd = mycpu;
+#ifdef SMP
     int count;
+#endif
 
     mask &= ~poll->cs_mask;
     poll->cs_mask |= mask;
Index: kern/lwkt_rwlock.c
===================================================================
RCS file: /cvs/src/sys/kern/lwkt_rwlock.c,v
retrieving revision 1.4
diff -u -r1.4 lwkt_rwlock.c
--- kern/lwkt_rwlock.c	20 Jul 2003 01:37:22 -0000	1.4
+++ kern/lwkt_rwlock.c	22 Feb 2004 07:18:34 -0000
@@ -41,17 +41,25 @@
 void
 lwkt_rwlock_init(lwkt_rwlock_t lock)
 {
-    lwkt_init_wait(&lock->rw_wait);
+    lwkt_wait_init(&lock->rw_wait);
+    lock->rw_owner = NULL;
+    lock->rw_count = 0;
+    lock->rw_requests = 0;
 }
 
-#if 0
+void
+lwkt_rwlock_uninit(lwkt_rwlock_t lock)
+{
+    /* empty */
+}
 
 void
 lwkt_exlock(lwkt_rwlock_t lock, const char *wmesg)
 {
+    lwkt_tokref ilock;
     int gen;
 
-    lwkt_gettoken(&lock->rw_token);
+    lwkt_gettoken(&ilock, &lock->rw_token);
     gen = lock->rw_wait.wa_gen;
     while (lock->rw_owner != curthread) {
 	if (lock->rw_owner == NULL && lock->rw_count == 0) {
@@ -60,34 +68,35 @@
 	}
 	++lock->rw_requests;
 	lwkt_block(&lock->rw_wait, wmesg, &gen);
-	lwkt_regettoken(&lock->rw_token);
 	--lock->rw_requests;
     }
     ++lock->rw_count;
-    lwkt_reltoken(&lock->rw_token);
+    lwkt_reltoken(&ilock);
 }
 
 void
 lwkt_shlock(lwkt_rwlock_t lock, const char *wmesg)
 {
+    lwkt_tokref ilock;
     int gen;
 
-    lwkt_gettoken(&lock->rw_token);
+    lwkt_gettoken(&ilock, &lock->rw_token);
     gen = lock->rw_wait.wa_gen;
     while (lock->rw_owner != NULL) {
 	++lock->rw_requests;
 	lwkt_block(&lock->rw_wait, wmesg, &gen);
-	lwkt_regettoken(&lock->rw_token);
 	--lock->rw_requests;
     }
     ++lock->rw_count;
-    lwkt_reltoken(&lock->rw_token);
+    lwkt_reltoken(&ilock);
 }
 
 void
 lwkt_exunlock(lwkt_rwlock_t lock)
 {
-    lwkt_gettoken(&lock->rw_token);
+    lwkt_tokref ilock;
+
+    lwkt_gettoken(&ilock, &lock->rw_token);
     KASSERT(lock->rw_owner != NULL, ("lwkt_exunlock: shared lock"));
     KASSERT(lock->rw_owner == curthread, ("lwkt_exunlock: not owner"));
     if (--lock->rw_count == 0) {
@@ -95,19 +104,20 @@
 	if (lock->rw_requests)
 	    lwkt_signal(&lock->rw_wait, 1);
     }
-    lwkt_reltoken(&lock->rw_token);
+    lwkt_reltoken(&ilock);
 }
 
 void
 lwkt_shunlock(lwkt_rwlock_t lock)
 {
-    lwkt_gettoken(&lock->rw_token);
+    lwkt_tokref ilock;
+
+    lwkt_gettoken(&ilock, &lock->rw_token);
     KASSERT(lock->rw_owner == NULL, ("lwkt_shunlock: exclusive lock"));
     if (--lock->rw_count == 0) {
 	if (lock->rw_requests)
 	    lwkt_signal(&lock->rw_wait, 1);
     }
-    lwkt_reltoken(&lock->rw_token);
+    lwkt_reltoken(&ilock);
 }
 
-#endif
